diff --git a/ChangeLog b/ChangeLog
index ce7e0d53d..667c9fb10 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -39,6 +39,9 @@
 	issues when file name encoding doesn't match system encoding.  Thanks to
 	Stas Panteleev.
 
+	Made leaving wrong (unexpectedly removed) directory more robust.  Thanks
+	to willemw12.
+
 	Fixed search messages in menus (nth time...).
 
 	Fixed automatic finishing in some situation when no terminal is available.
diff --git a/src/filelist.c b/src/filelist.c
index 896889e9a..a895244fb 100644
--- a/src/filelist.c
+++ b/src/filelist.c
@@ -2007,7 +2007,8 @@ leave_invalid_dir(FileView *view)
 		return;
 	}
 
-	while(!directory_accessible(path) && is_path_well_formed(path))
+	while((!is_dir(path) || !directory_accessible(path)) &&
+			is_path_well_formed(path))
 	{
 		if(try_updir_from_fuse_mount(path, view))
 		{
